<template>
  <q-layout view="lHh Lpr lFf">
    <q-header flat class="bg-white text-black" height-hint="100">
      <!-- Toolbar for mobile -->
      <q-toolbar
        class="portal-toolbar-height q-pt-lg justify-between"
        v-if="screenWidth <= 767"
      >
        <q-btn
          size="sm"
          color="#fff"
          style="background-color: #4c1cc0"
          @click="drawerLeft = !drawerLeft"
          round
          unelevated
          icon="eva-menu"
        />
        <q-avatar>
          <img alt="Vigan City Logo" src="~assets/vigan_logo.png" />
        </q-avatar>
        <div></div>
        <!-- <q-btn size="md" flat round dense icon="notifications_none" /> -->
      </q-toolbar>

      <!-- Toobar for big screens -->
      <q-toolbar class="portal-toolbar-height" v-if="screenWidth >= 768">
        <q-avatar>
          <img alt="Vigan City Logo" src="~assets/vigan_logo.png" />
        </q-avatar>
        <q-toolbar-title>
          <div class="text">
            <div class="text-title">VIGAN CITY</div>
            <div class="text-subtitle">Job Matching Portal</div>
          </div>
        </q-toolbar-title>

        <div class="navigation-tab q-mx-xl">
          <q-tabs inline-label align="justify">
            <template
              v-for="(navigation, key) in PORTAL_JOBSEEKER_MENU_OPTIONS"
              :key="key"
            >
              <q-route-tab
                no-caps
                :to="navigation.link"
                :label="navigation.label"
              >
                <q-badge
                  v-show="notificationCount(navigation.label)"
                  color="negative"
                  rounded
                  class="q-ml-sm"
                >
                  <span class="notification q-mx-auto">
                    {{ notificationCount(navigation.label) }}
                  </span>
                </q-badge>
              </q-route-tab>
            </template>
          </q-tabs>
        </div>

        <q-space />
        <!-- <notifications-menu></notifications-menu> -->
        <!-- <messages-menu></messages-menu> -->
        <user-account-menu></user-account-menu>
      </q-toolbar>
    </q-header>

    <progress-header v-if="cv_or_resume === null && profile_picture === null" />

    <!-- DRAWER FOR MOBILE -->
    <q-drawer
      v-model="drawerLeft"
      :breakpoint="700"
      :width="screenWidth > 500 ? 500 : screenWidth"
      behavior="mobile"
      overlay
      class="text-white"
      style="background: #4c1cc0fa"
      v-if="$q.screen.lt.md"
    >
      <q-scroll-area class="fit">
        <div class="q-py-md q-px-xl">
          <q-btn
            @click="drawerLeft = !drawerLeft"
            size="md"
            flat
            color="white"
            round
            dense
            icon="eva-close"
            class="q-my-lg"
          />
          <div class="flex items-center q-my-lg">
            <q-avatar>
              <img alt="Vigan City Logo" src="~assets/vigan_logo.png" />
            </q-avatar>
            <div class="">
              <div
                class="white-text q-ml-lg text-weight-bold"
                style="font-size: 20px"
              >
                Job Seeker Portal
              </div>
            </div>
          </div>
          <div class="menu-container">
            <q-list dense padding>
              <q-item
                clickable
                v-ripple
                v-for="(
                  navigation, key
                ) in PORTAL_JOBSEEKER_MENU_OPTIONS_MOBILE"
                :key="key"
                :to="navigation.link"
                :active-class="'mobile-link-active'"
                exact
              >
                <q-item-section class="text-weight-bold q-py-md">
                  <p class="mobile-link">
                    <span
                      class="dot-active"
                      style="font-size: 20px; margin-right: 10px"
                      >•</span
                    >
                    {{ navigation.label }}
                  </p>
                </q-item-section>
              </q-item>
            </q-list>

            <q-btn
              unelevated
              color="white"
              style="
                color: #4c1cc0fa !important;
                width: 100%;
                font-size: 15px;
                margin-top: 60px;
              "
              label="SIGN OUT"
              @click="doLogout"
              class="q-my-lg"
            />
          </div>
        </div>
      </q-scroll-area>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, computed, ref } from "vue";
// import NotificationsMenu from "../portals/partials/NotificationsMenu.vue";
// import MessagesMenu from "../portals/partials/MessagesMenu.vue";
import UserAccountMenu from "../portals/partials/UserAccountMenu.vue";
import ProgressHeader from "./partials/ProgressHeader.vue";
import {
  PORTAL_JOBSEEKER_MENU_OPTIONS,
  PORTAL_JOBSEEKER_MENU_OPTIONS_MOBILE,
} from "../portals/constants";
import { AUTH_ROUTE_NAMES } from "src/modules/auth/constants";
import { useRoom } from "src/modules/messages/store/room";
import { useApplication } from "src/modules/messages/store/application";
import { usePusher } from "../portals/store/pusher";
import { useUser } from "src/layouts/portals/store/user";
import { pusher, pusherConfig } from "boot/pusher";
import CryptoJS from "crypto-js";
import usePageRouter from "src/hooks/pageRouter";
import { onMounted, onUnmounted } from "vue";
import { useReference } from "src/modules/auth/store/reference";

export default defineComponent({
  components: {
    // NotificationsMenu,
    // MessagesMenu,
    UserAccountMenu,
    ProgressHeader,
  },
  name: "JobseekerPortalLayout",

  setup() {
    const roomStore = useRoom();
    const { getRoomIDs, getRooms, updateRooms, resetRooms } = roomStore;

    const pusherStore = usePusher();
    const { addPusherChannel, clearPusherChannel } = pusherStore;

    const applicationStore = useApplication();
    const userStore = useUser();
    const referenceStore = useReference();

    const userID = LocalStorage.getItem("auth").id;

    const { router, route } = usePageRouter();

    const screenWidth = ref(0);

    onMounted(() => {
      fetchData();
      window.addEventListener("resize", screenResize);
      // setTimeout(() => {
      //   window.location.reload();
      // }, 1000);
    });

    onUnmounted(() => {
      pusherStore.channels.forEach((channelName) => {
        // console.log("unsubscribe: ", channelName);
        let data = {
          channel: channelName,
        };
        pusher.send_event("pusher:unsubscribe", data);
      });
      clearPusherChannel();
      resetRooms();

      roomStore.$dispose();
      pusherStore.$dispose();
      applicationStore.$dispose();
      userStore.$dispose();
      referenceStore.$dispose();

      document.removeEventListener("resize", screenResize);
    });

    const fetchData = async () => {
      subscribeToPusherChannel("private-user-" + userID);
      await getRoomIDs();
      // await getRooms();
      subscribeToRoomChannel();
      pusherBind();
    };

    const subscribeToRoomChannel = () => {
      roomStore.roomIDs.forEach((room) => {
        const channelName = "private-room-" + room.id;
        subscribeToPusherChannel(channelName);
      });
    };

    const subscribeToPusherChannel = (channelName) => {
      if (!pusherStore.channels.includes(channelName)) {
        if (channelName.includes("private-")) {
          let value = pusher.connection.socket_id + ":" + channelName;

          const signature = CryptoJS.HmacSHA256(
            value,
            pusherConfig.APP_SECRET
          ).toString(CryptoJS.enc.Hex);

          let data = {
            auth: pusherConfig.APP_KEY + ":" + signature,
            channel: channelName,
          };

          pusher.send_event("pusher:subscribe", data);
        } else {
          pusher.subscribe(channelName);
        }
        addPusherChannel(channelName);
      }
    };

    const pusherBind = () => {
      pusher.connection.bind("message", (msg) => {
        if (msg.event == "room") {
          console.log("event: room");
          console.log("message: ", msg);
          if (msg.data.userId == userID) {
            updateRooms(msg.data.data, route.name);
            let room = roomStore.room.find(
              (item) => item.id === msg.data.data.id
            );
            console.log("room: ", room);
            if (!room) {
              const channelName = "private-room-" + msg.data.data.id;
              subscribeToPusherChannel(channelName);
            }
          }
        }
      });
    };

    const notificationCount = (title) => {
      if (title == "Messages") {
        const unReadNotifications = roomStore.rooms.filter((item) =>
          isUnread(item.latest_message)
        );
        return unReadNotifications.length;
      }
      return 0;
    };

    // const notificationCount = computed(() => {
    //   const unReadNotifications = roomStore.rooms.filter((item) =>
    //     isUnread(item.latest_message)
    //   );
    //   return unReadNotifications.length;
    // });

    const isUnread = (message) => {
      if (message == null) return false;
      if (message.user_id != userID) {
        return message.read_at == null;
      }
      return false;
    };

    const doLogout = () => {
      LocalStorage.clear();
      router.push({ name: AUTH_ROUTE_NAMES.Login.name });
    };

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    // fetchData();
    screenResize();

    return {
      drawerLeft: ref(false),
      roomStore,
      pusherStore,
      PORTAL_JOBSEEKER_MENU_OPTIONS,
      PORTAL_JOBSEEKER_MENU_OPTIONS_MOBILE,
      userID,
      notificationCount,
      cv_or_resume: computed(() => LocalStorage.getItem("auth").cv_or_resume),
      profile_picture: computed(
        () => LocalStorage.getItem("auth").profile_picture
      ),
      doLogout,
      screenWidth,
      screenResize,
    };
  },
});
</script>

<style lang="scss" scoped>
.q-layout {
  background-color: #f1f1f1;
}

.q-header {
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 -10px 20px black;
}

.q-avatar,
img {
  height: 50px !important;
  width: 50px !important;
}
.portal {
  &-toolbar {
    &-height {
      height: 100px;
    }
  }
}
.text {
  line-height: 20px;
  width: 105px;
  &-title {
    font-weight: 800;
    color: #4c1cc0;
    font-size: 15px;
  }
  &-subtitle {
    font-weight: 600;
    color: $dark;
    font-size: 11px;
  }
}

div.q-badge {
  width: 22px;
  height: 22px;
  border-radius: 50px !important;
  display: flex;
  justify-content: center;
  align-items: center;
}

.mobile-link {
  font-size: 16px;
  margin-bottom: 0;
  color: #fff;
}

.dot-active {
  display: none;
}

.mobile-link-active {
  .mobile-link {
    font-size: 20px;
    font-weight: bold;
  }

  .dot-active {
    display: inline-block;
  }
}

@media only screen and (max-width: 1024px) and (min-width: 768px) {
  .navigation-tab {
    margin: 0 !important;
  }

  :deep(.q-tab) {
    margin-right: 15px !important;
    padding: 5px 15px !important;

    .q-tab__label {
      font-size: 12px !important;
    }
  }
}
</style>
